RoleCreateView = RoleCreateView or BaseClass(XuiBaseView)
ROLE_CREATE_FONT_SIZE = 32

ROLE_MODEL_SHOW_EFFECT = {
	[0] = {101, 103, 105},
	[1] = {102, 104, 106}
}
function RoleCreateView:__init()
	self.close_mode = CloseMode.CloseDestroy
	self.zorder = COMMON_CONSTS.ZORDER_LOGIN
	self.is_async_load = false
		--创建角色

	self.texture_path_list[1] = 'res/xui/role_create.png'
	self.texture_path_list[2] = 'res/xui/login.png'
	self.config_tab = {
		{"role_create_ui_cfg", 1, {0}},
	}

	self.last_send_create_time = 0
	self.bg_container = nil
end

function RoleCreateView:__delete()

end

function RoleCreateView:ReleaseCallBack()
	self.role_model_sprite:DeleteMe()
	self.role_model_sprite = nil

	if self.bg_container then
		self.bg_container:removeFromParent()
		self.bg_container = nil
	end	
end

function RoleCreateView:LoadCallBack()
	self.layout_right = self.node_tree.layout_create_container.layout_right
	self.layout_left = self.node_tree.layout_create_container.layout_left
	self.layout_center = self.node_tree.layout_create_container.layout_center
	self.edit_name = self.node_tree.layout_create_container.layout_center.edit_name_1.node

	self.edit_name:setFontName(COMMON_CONSTS.FONT)
	self.edit_name:setFontSize(ROLE_CREATE_FONT_SIZE)
	self.edit_name:setFontColor(COLOR3B.G_W2)
	self.edit_name:registerScriptEditBoxHandler(BindTool.Bind2(ChatData.ExamineEditNameNum, self.edit_name, 12))

	self.role_name = ""
	self.prof_index = math.random(1, 1)
	self.role_sex = math.random(0, 1)

	self.trun_complete_num = 0
	self.is_play_action = false
	self.role_create_view_is_show = false

	self.turn_queue = {}
	
	self.role_model_sprite = SingleAnimateSprite.New()
	self.layout_center.role_model_layout.node:addChild(self.role_model_sprite:GetView())

	self:RigisterRoleCreateEvents()
end

function RoleCreateView:CloseCallBack()
	self:CreateBgDes(false)
end

function RoleCreateView:ProfChange(prof, ignore)
	if self.prof_index ~= prof or ignore then
		self.prof_index = prof
		-- if 1 == self.prof_index or 3 == self.prof_index then --1 3男，2 4女
		-- 	self.role_sex = GameEnum.MALE
		-- else
		-- 	self.role_sex = GameEnum.FEMALE
		-- end

		self:TurnComplete()
	end
end

function RoleCreateView:SexHandler(sex)
	if self.role_sex ~= sex then
		self.role_sex = sex
		self:TurnComplete()
	end
end

function RoleCreateView:RigisterRoleCreateEvents()
	for i = 1, 1 do
		XUI.AddClickEventListener(self.layout_right["btn_prof" .. i].node, BindTool.Bind(self.ProfChange, self, i))
	end
	XUI.AddClickEventListener(self.layout_left.btn_return.node, BindTool.Bind1(self.ReturnToLogin, self))
	XUI.AddClickEventListener(self.layout_center.btn_random.node, BindTool.Bind1(self.RandomName, self))
	XUI.AddClickEventListener(self.layout_right.btn_enter.node, BindTool.Bind1(self.EnterCreateRole, self))
	XUI.AddClickEventListener(self.layout_center.btn_sex0.node, BindTool.Bind(self.SexHandler, self, 0))
	XUI.AddClickEventListener(self.layout_center.btn_sex1.node, BindTool.Bind(self.SexHandler, self, 1))
end

function RoleCreateView:OpenRoleCreate()
	self:SetCreateVisible(true)
	self.prof_index = math.random(1, 1)
	self.role_sex = math.random(0, 0)
	self:ResetRolePosition()
	self:RandomName()
	
end

function RoleCreateView:ReturnToLogin()
	self:SetCreateVisible(false)

	self.role_name = ""
	self.prof_index = math.random(1, 1)
	self.role_sex = math.random(0, 0)
	self.edit_name:setText("")

	self.action_list = {}

	
	local user_vo = GameVoManager.Instance:GetUserVo()
	if next(user_vo:GetRoleList()) then
		LoginController.Instance:DoOpenCombineSelectRoleView()
	else
		LoginController.Instance:CreateRoleViewReturnLogin()
	end
end

function RoleCreateView:SetCreateVisible(is_show)
	self.role_create_view_is_show = is_show
	LoginController.Instance.loginview.node_tree.layout_bg.node:setVisible(not is_show)
	LoginController.Instance.loginview.node_tree.layout_bg.layout_select_sever_list.node:setVisible(not is_show)
	LoginController.Instance.loginview.node_tree.layout_bg.layout_server_recommend.node:setVisible(not is_show)
	LoginController.Instance.loginview.node_tree.layout_bg.layout_all.node:setVisible(not is_show)
	--LoginController.Instance.loginview:SetLogoVisible(not is_show)
	self.root_node:setVisible(is_show)
	self:CreateBgDes(is_show)
end

function RoleCreateView:CreateBgDes(is_show)
	if is_show then
		if not self.bg_container then
			local screen_w = HandleRenderUnit:GetWidth()
			local screen_h = HandleRenderUnit:GetHeight()

			local bg_path = "agentres/Createrole_bg.jpg"
			if not cc.FileUtils:getInstance():isFileExist(bg_path) then
				bg_path = ResPath.GetBigPainting("role_create", true)
				if IS_AUDIT_VERSION then
					local temp_path = ResPath.GetBigPainting("role_create_ios", true)
					if cc.FileUtils:getInstance():isFileExist(temp_path) then
						bg_path = temp_path
					end	
				end	
			end	

			self.bg_container = XUI.CreateLayout(screen_w * 0.5, screen_h * 0.5, screen_w, screen_h)
			HandleRenderUnit:AddUi(self.bg_container, self.zorder - 1)

			local bg = XUI.CreateImageView(screen_w / 2, screen_h / 2, bg_path , true)
			self.bg_container:addChild(bg,-1)
			local size = bg:getContentSize()
			bg:setScaleX(screen_w / size.width)
			bg:setScaleY(screen_h / size.height)
			
			local path = XUI.CreateImageViewScale9(screen_w/2, screen_h / 2, screen_w, screen_h, ResPath.GetCommon("img9_138"), true) 
		 	self.bg_container:addChild(path, -2)
		 end	
	else
		if self.bg_container then
			self.bg_container:removeFromParent()
			self.bg_container = nil
		end	
	end	
end	

function RoleCreateView:RoleCreateViewIsShow()
	return self.role_create_view_is_show
end

function RoleCreateView:ResetRolePosition()
	self:ProfChange(self.prof_index, true)  --GameEnum.ROLE_PROF_1
end

function RoleCreateView:TurnComplete()
	--清除所有动作
	self.is_play_action = false
	self.trun_complete_num = 0

	
	self.layout_right.btn_enter.node:setEnabled(true)
	self.layout_left.btn_return.node:setEnabled(true)

	self.node_t_list.img_prof.node:loadTexture(ResPath.GetRoleCreate("title_prof"..self.prof_index))

	self.role_model_sprite:SetAnimate(ROLE_MODEL_SHOW_EFFECT[self.role_sex][self.prof_index],1,12,0xffffffff,0.1)
	
	for i = 1, 1 do
		local node = self.layout_right["btn_prof" .. i].node
		if i == self.prof_index then
			node:loadTexture(ResPath.GetRoleCreate("prof"..self.prof_index))	
		else
			node:loadTexture(ResPath.GetRoleCreate("prof_normal_"..i))
		end
	end

	for i = 0, 1 do
		local node = self.layout_center["btn_sex" .. i ].node
		if i == self.role_sex then
			node:loadTexture(ResPath.GetRoleCreate("sex_select_"..i))
		else	
			node:loadTexture(ResPath.GetRoleCreate("sex_"..i))
		end	
	end	

	--当前的原话播放动画
	self:RandomName()
end


function RoleCreateView:RandomName()
	self.edit_name:setText(UserVo.RandomName(self.role_sex))
end

function RoleCreateView:EnterCreateRole()
	local name_str = self.edit_name:getText()
	local len = string.len(name_str)
	if len <= 0 then
		SysMsgCtrl.Instance:ErrorRemind(Language.Login.EditName, true)
		return
	end

	self.role_name = ChatFilter.Instance:Filter(name_str)
	self.edit_name:setText(self.role_name)

	if AdapterToLua:utf8FontCount(self.role_name) > 12 or AdapterToLua:utf8CharCount(self.role_name) > 6 then
		SysMsgCtrl.Instance:ErrorRemind(Language.Login.NameToLong, true)
		return
	end
	
	if ChatFilter.Instance:IsIllegal(self.role_name, true) then
		SysMsgCtrl.Instance:ErrorRemind(Language.Common.IllegalContent, true)
		return
	end

	local i, j = string.find(self.role_name, "*")
	if i ~= nil and j ~= nil then
		SysMsgCtrl.Instance:ErrorRemind(Language.Common.IllegalContent, true)
		return
	end
	local qukong_text = string.gsub(self.role_name, "%s", "")
	local qukong_text_len = string.len(qukong_text)  
	--判断输入的名字是否带空格	
	if qukong_text_len ~= len then
		SysMsgCtrl.Instance:ErrorRemind(Language.Common.IllegalContent, true)
		return 
	end		

	if GLOBAL_CONFIG.param_list.switch_list.open_CharacterCreation ~= nil and GLOBAL_CONFIG.param_list.switch_list.open_CharacterCreation == false then
		SysMsgCtrl.Instance:ErrorRemind(Language.Common.NotCreateRoleTip, true)
		return
	end	
		
	if Status.NowTime > self.last_send_create_time + 1 then
		MainProber:Step(MainProber.STEP_SERVER_CREATE_ROLE_BEG, self.role_name, self.prof_index, self.role_sex)
		if MainProber.Step2 then 
			MainProber.role_name = mime.b64(self.role_name)
			MainProber:Step2(MainProber.PHP_PUSH_CREATE_ROLE_START, MainProber.user_id, MainProber.server_id, MainProber.role_name) 
		end

		self.last_send_create_time = Status.NowTime
		LoginController.Instance:SendCreateRole(self.role_name, self.prof_index, self.role_sex)
	end
end
